#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <locale.h>
#include <langinfo.h>

#include "ntypes.h"
#include "nwlocale.h"
#include "unicode.h"
#include "nwclxcon.h"
#include "nwdsapi.h"
//#include "nwnet.h"
#include "nwserver.h"
#include "nwncpext.h"
#include <assert.h>

void mb_out(char *str)
{
   char *pch = str;

	while (*pch)
		printf("%02x ", *pch++);
	printf("\n");
}

void uni_out(unicode *s)
{
	while (*s)
		printf("%04x ", *s++);
	printf("\n");
}


void uni_print(unicode *s)
{
   while (*s)
      printf("%lc", *s++);
   printf("\n");
}


int main(int argc, char **argv)
{
	char *s;
	size_t len;
	unsigned char chbuf[128];
   unicode unibuf[128], unibuf2[128];
   nptr uniHandle;
	LCONV lconv;
//	wchar_t wcbuf[128];

	// UTF-8 Strings
	nuint8 *str1 = (nuint8 *)"Shakespeare";
	nuint8 *str2 = (nuint8 *)"Schöne Grüße";		// German (Europe)
	nuint8 *str3 = (nuint8 *)"Ολυμπιάδας";		// Greek
	nuint8 *str4 = (nuint8 *)"アテネオリンピック特集";	// Japanese

	// UNC Strings
//	wchar_t *wstr1 = L"Shakespeare";
//	wchar_t *wstr2 = L"Schöne Grüße";	// German (Europe)
//	wchar_t *wstr3 = L"Ολυμπιάδας";		// Greek
//	wchar_t *wstr4 = L"アテネオリンピック特集"; // Japanese

   char *pos, *next;

	NWLsetlocale(NLC_ALL, "en_US.UTF-8");

	NWLlocaleconv(&lconv);
	printf("NWLlocaleconv: country = %d\n", lconv.country_id);
	printf("NWLlocaleconv: code page = %d\n", lconv.code_page);

   printf("\n\nConverted UTF-8 -> Unicode strings:\n");

   NWGetUnicodeToLocalHandle(&uniHandle);

   NWLocalToUnicode(uniHandle, unibuf, 128, str1, 0, 0);
   NWUnicodeToLocal(uniHandle, chbuf, 128, unibuf, 0, 0);
   NWLocalToUnicode(uniHandle, unibuf, 128, chbuf, 0, &len);
   uni_print(unibuf);
   printf("len = %u\n", len);
   uni_out(unibuf);

   NWLocalToUnicode(uniHandle, unibuf, 128, str2, 0, 0);
   NWUnicodeToLocal(uniHandle, chbuf, 128, unibuf, 0, 0);
   NWLocalToUnicode(uniHandle, unibuf, 128, chbuf, 0, &len);
   uni_print(unibuf);
   printf("len = %u\n", len);
   uni_out(unibuf);

   NWLocalToUnicode(uniHandle, unibuf, 128, str3, 0, 0);
   NWUnicodeToLocal(uniHandle, chbuf, 128, unibuf, 0, 0);
   NWLocalToUnicode(uniHandle, unibuf, 128, chbuf, 0, &len);
   uni_print(unibuf);
   printf("len = %u\n", len);
   uni_out(unibuf);

   NWLocalToUnicode(uniHandle, unibuf, 128, str4, 0, 0);
   NWUnicodeToLocal(uniHandle, chbuf, 128, unibuf, 0, 0);
   NWLocalToUnicode(uniHandle, unibuf, 128, chbuf, 0, &len);
   uni_print(unibuf);
   printf("len = %u\n", len);
   uni_out(unibuf);

   printf("\nNWUnicodeToCollation()\n");
   NWUnicodeToCollation(uniHandle, unibuf2, 32, unibuf, 0, &len);
   uni_print(unibuf);
   printf("len = %u\n", len);
   uni_out(unibuf2);

   // Test NWPrevChar and NWNextChar

   s = (char *)str4;

   printf("\nNWPrevChar()\n");
   pos = s + strlen(s);
   do
   {
      pos = NWPrevChar(s, pos);
      printf("%s", pos);
      printf("\n");
   } while (pos != s);

   printf("\nNWNextChar()\n");
   next = s;
   while (*next)
   {
      printf("%s", next);
      printf("\n");
      next = NWNextChar(next);
   };

   printf("\nUnicodeToMonocode()\n");
   NWLocalToUnicode(uniHandle, unibuf, 128, str1, 0, 0);
   NWUnicodeToMonocase(uniHandle, unibuf2, 128, unibuf, &len);
   uni_print(unibuf);
   uni_print(unibuf2);
   NWLocalToUnicode(uniHandle, unibuf, 128, str2, 0, 0);
   NWUnicodeToMonocase(uniHandle, unibuf2, 128, unibuf, &len);
   uni_print(unibuf);
   uni_print(unibuf2);
   NWLocalToUnicode(uniHandle, unibuf, 128, str3, 0, 0);
   NWUnicodeToMonocase(uniHandle, unibuf2, 128, unibuf, &len);
   uni_print(unibuf);
   uni_print(unibuf2);
   NWLocalToUnicode(uniHandle, unibuf, 128, str4, 0, 0);
   NWUnicodeToMonocase(uniHandle, unibuf2, 128, unibuf, &len);
   uni_print(unibuf);
   uni_print(unibuf2);

   NWUSStandardUnicodeInit();

   NWUSByteToUnicode(unibuf, 128, str1, 0);
   NWUSUnicodeToByte(chbuf, 128, unibuf, 0);
   NWUSByteToUnicode(unibuf, 128, str1, &len);
   uni_print(unibuf);
   printf("len = %u\n", len);
   uni_out(unibuf);

   NWUSStandardUnicodeRelease();

   /*****************************************************************************/

   nuint    codepage = 0;  /* U.S. OEM code page in this example. */
   pCONVERT pconv;
   nint     icode;
   nuint    actualLen;
   pnuint8  byteIn = (nuint8 *)"The skull and crossbones character: [2620]";
   unicode  uniOut[80];

   /* Load a byte/uni converter, returning a handle to the converter.
      Error checking not shown. */
   icode = NWUXLoadByteUnicodeConverter(codepage, &pconv);


/* Example 1:  Convert using the default converter behavior.
   The byte sequence "[2620]" is converted to a single unicode character.
*/

   icode = NWUXByteToUnicode( pconv, uniOut, 80, byteIn, &actualLen );

   if (icode)
      printf("NWUXByteToUnicode returned error: %04X\n", icode);
   else
      assert(uniOut[36] == 0x2620 && actualLen == 37);


/* Example 2:  Change the behavior of this converter to disable the
      the automatic conversion of "[nnnn]" to a unicode character.
      The "[2620]" sequence will just be converted normally to 6
      unicode characters '[', '2', '0', '2', '6', ']'.
*/

   /* Disable byte-to-uni filtering, don't change uni-to-byte behavior.
      Error checking from this routine not shown. */
   NWUXSetScanAction(pconv, NWU_DISABLED, NWU_UNCHANGED_ACTION);

   /* This conversion should produce the unicode string:
          "The skull and crossbones character: [2620]"
   */
   icode = NWUXByteToUnicode( pconv, uniOut, 80, byteIn, &actualLen );

   if (icode)
      printf("NWUXByteToUnicode returned error: %04X\n", icode);
   else
      assert(uniOut[36] == '[' && actualLen == 42);

   NWUXUnloadConverter(pconv);


   /*****************************************************************************/
//   nuint    codepage = 0;    /* U.S. OEM code page in this example. */
//   pCONVERT pconv;
//   nint     icode;
//   nuint    actualLen;
   unicode  uniIn[5] = { 'a', 'b', 'c', 0x2620, 0};
   nuint8   byteOut[80];

   /* Load a byte/uni converter, returning a handle to the converter.
      Error checking not shown. */
   icode = NWUXLoadByteUnicodeConverter(codepage, &pconv);


/* Example 1:  Convert using the default converter behavior.
   The unmappable unicode 0x2620 character is converted to the
   6-byte string "[2620]".
*/
   icode = NWUXUnicodeToByte( pconv, byteOut, 80, uniIn, &actualLen );

   if (icode)
      printf("NWUXUnicodeToByte returned error: %04X\n", icode);
   else
//      assert(strcmp(byteOut,"abc[2620]")==0 && actualLen==9);


/* Example 2:  Change the behavior of this converter to return an
   error if an unmappable character is encountered.  Leave behavior
   for byte-to-uni unmappable character unchanged.
   Error checking not shown.
*/
   icode = NWUXSetNoMapAction( pconv, NWU_UNCHANGED_ACTION,
                               NWU_RETURN_ERROR );

   /* This should return an error due to the unmappable uni char 0x2620 */
   icode = NWUXUnicodeToByte( pconv, byteOut, 80, uniIn, &actualLen );

//   assert(icode == NWU_UNMAPPABLE_CHAR && actualLen == 3);


   NWUXUnloadConverter(pconv);

	return 0;
}
